<?php

namespace Liberty\Services\Emisor\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for guia StructType
 * @subpackage Structs
 */
class Guia extends AbstractStructBase
{
    /**
     * The fechaGuia
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $fechaGuia;
    /**
     * The nombreEmisorGuia
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $nombreEmisorGuia;
    /**
     * The numeroGuia
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $numeroGuia;
    /**
     * Constructor method for guia
     * @uses Guia::setFechaGuia()
     * @uses Guia::setNombreEmisorGuia()
     * @uses Guia::setNumeroGuia()
     * @param int $fechaGuia
     * @param string $nombreEmisorGuia
     * @param int $numeroGuia
     */
    public function __construct($fechaGuia = null, $nombreEmisorGuia = null, $numeroGuia = null)
    {
        $this
            ->setFechaGuia($fechaGuia)
            ->setNombreEmisorGuia($nombreEmisorGuia)
            ->setNumeroGuia($numeroGuia);
    }
    /**
     * Get fechaGuia value
     * @return int|null
     */
    public function getFechaGuia()
    {
        return $this->fechaGuia;
    }
    /**
     * Set fechaGuia value
     * @param int $fechaGuia
     * @return \Liberty\Services\Emisor\StructType\Guia
     */
    public function setFechaGuia($fechaGuia = null)
    {
        // validation for constraint: int
        if (!is_null($fechaGuia) && !(is_int($fechaGuia) || ctype_digit($fechaGuia))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($fechaGuia, true), gettype($fechaGuia)), __LINE__);
        }
        $this->fechaGuia = $fechaGuia;
        return $this;
    }
    /**
     * Get nombreEmisorGuia value
     * @return string|null
     */
    public function getNombreEmisorGuia()
    {
        return $this->nombreEmisorGuia;
    }
    /**
     * Set nombreEmisorGuia value
     * @param string $nombreEmisorGuia
     * @return \Liberty\Services\Emisor\StructType\Guia
     */
    public function setNombreEmisorGuia($nombreEmisorGuia = null)
    {
        // validation for constraint: string
        if (!is_null($nombreEmisorGuia) && !is_string($nombreEmisorGuia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombreEmisorGuia, true), gettype($nombreEmisorGuia)), __LINE__);
        }
        $this->nombreEmisorGuia = $nombreEmisorGuia;
        return $this;
    }
    /**
     * Get numeroGuia value
     * @return int|null
     */
    public function getNumeroGuia()
    {
        return $this->numeroGuia;
    }
    /**
     * Set numeroGuia value
     * @param int $numeroGuia
     * @return \Liberty\Services\Emisor\StructType\Guia
     */
    public function setNumeroGuia($numeroGuia = null)
    {
        // validation for constraint: int
        if (!is_null($numeroGuia) && !(is_int($numeroGuia) || ctype_digit($numeroGuia))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numeroGuia, true), gettype($numeroGuia)), __LINE__);
        }
        $this->numeroGuia = $numeroGuia;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Liberty\Services\Emisor\StructType\Guia
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
